<?php

namespace Ulmus\Entity\Field;

use Ulmus\Entity\EntityObjectInterface;

class Datetime extends \DateTime implements EntityObjectInterface {

    public string $format = "Y-m-d H:i:s";

    public function load(...$arguments)
    {
        $value = $arguments[0];

        # From Timestamp
        if ( is_numeric($value) ) {
            return new static("@$value");
        }

        return new static($value);
    }

    public function save()
    {
        return $this->__toString();
    }

    public function __toString()
    {
        return $this->format($this->format);
    }

    public function formatLocale(string $format) : string
    {
        return strftime($format, $this->getTimestamp());
    }
}
